package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description:
 * @CreateDate 2021/10/20 10:27
 * @Author 尹肖
 */
public interface IBaseMesService<T extends BaseBean> {

    /**
     * 获取当前服务Class
     *
     * @return
     */
    Class<T> getMesClass();

    @ApiOperation(value = "查询列表", notes = "组合查询，外带分页功能")
    ListPager<T> queryPager(T bean, Pager pager);

    @ApiOperation(value = "查询列表", notes = "组合查询，外带分页功能")
    ListPager<T> queryPagerWhere(Pager pager, DdlPackBean packBean);

    @ApiOperation(value = "查询列表", notes = "查询所有数据")
    List<T> findAll(DdlPackBean packBean);

    @ApiOperation(value = "查询数据", notes = "根据ID查询信息")
    T get(Long id);

    @ApiOperation(value = "新增信息", notes = "新增信息")
    T insert(T bean);

    @ApiOperation(value = "批量新增数据", notes = "批量新增数据")
    List<T> insertBatch(List<T> bean);

    @ApiOperation(value = "校验导入数据", notes = "校验导入数据")
    void validateImport(List<T> bean);

    @ApiOperation(value = "修改信息", notes = "修改信息")
    T update(T bean);

    @ApiOperation(value = "批量修改信息", notes = "批量修改信息")
    void updates(Iterable<T> beans);

    @ApiOperation(value = "删除数据", notes = "根据ID软删除信息")
    void deleteWeaklyById(Long id, String userName);

    @ApiOperation(value = "删除数据", notes = "根据ID批量删除信息")
    void deleteWeaklyByIds(Long[] ids, String userName);

    @ApiOperation(value = "强删除数据", notes = "根据ID强删除")
    void deleteById(Long id);

    @ApiOperation(value = "强删除数据", notes = "根据ID批量强删除")
    void deleteByIds(Long[] ids);

    @ApiOperation(value = "根据id更新启用或禁用", notes = "根据id更新启用或禁用")
    int updateValid(Long id, int status, String userName);
}
