package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesBom;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description:
 * @CreateDate 2024/04/16
 * @Author mingliang.li
 */
public interface IMesBomService extends IBaseMesService<MesBom> {

    /**
     * 查询MES组织模型数据返回树结构
     *
     * @param bom 组织代码
     * @return 组织模型数据返回树结构
     */
    @ApiOperation(value = "查询BOM树结构")
    List queryMesDataTreeByFirstFloor(MesBom bom);

    /**
     * 查询MES组织模型数据返回树结构
     *
     * @param bom 组织代码
     * @return 组织模型数据返回树结构
     */
    @ApiOperation(value = "查询BOM树结构")
    ListPager<MesBom> queryMesDataTree(MesBom bom, Pager pager);


}
