package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.mes.bean.MesEnum;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

public interface IMesEnumExtService extends IBaseMesService<MesEnum>{

    @ApiOperation("获取所有mes枚举")
    List<Map<String, Object>> getAllMesEnums();

    @ApiOperation("根据枚举名获取枚举")
    Map<String, Object> doGetMesEnumByEnumName(String enumName);

    @ApiOperation("通过class获取枚举")
    Map<String, Object> getEnumByClazzEnum(String enumName, Class clazz);

    @ApiOperation("通过class获取枚举的values")
    List<Map<String, Object>> getEnumValuesByClazzEnum(String var1, Class var2);

    @ApiOperation("根据枚举key获取枚举对应的value 获取缓存中的语言")
    Map<String, String> getEnumLangeuageKeyByClazzEnum(Class var1);

    @ApiOperation("新增或更新枚举")
    void saveEnums(String var1, String var2);

    @ApiOperation("获取所有枚举")
    List<Map<String, Object>> getAllEnums(String var1);

    @ApiOperation("根据枚举名获取枚举")
    Map<String, Object> getEnumByEnumName(String var1, String var2);
}
