package cn.estsh.i3plus.ext.mes.apiservice.config;

import cn.estsh.i3plus.ext.mes.apiservice.utils.HuaWeiOBSUtil;
import com.obs.services.ObsClient;
import lombok.Getter;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Description : HuaWeiCloudObsConfig
 * @Author :gsz
 * @Date 2024/6/11 13:28
 * @Modify
 **/
@Configuration
public class HuaWeiCloudObsConfig {

    @Value("${huaweiobs.bucketName}")
    @Getter
    private String bucketName;

    @Value("${huaweiobs.ak}")
    @Getter
    private String ak;

    @Value("${huaweiobs.sk}")
    @Getter
    private String sk;

    @Value("${huaweiobs.endPoint}")
    @Getter
    private String endPoint;

    @Bean
    public ObsClient getObsClient() {
        ObsClient obsClient = new ObsClient(ak, sk, endPoint);
        return obsClient;
    }
    @Bean
    public HuaWeiOBSUtil huaWeiOBSUtil() {
        return new HuaWeiOBSUtil(bucketName, ak, sk, endPoint);
    }
}
