package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCraftService;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesCraft;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description : 工艺信息
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/11 13:52
 * @Modify:
 **/
@Api(description = "工艺信息")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesCraft")
public class MesCraftController extends BaseMesController<MesCraft> {

    @Autowired
    private IMesCraftService mesCraftService;

    @GetMapping(value = "/find-mes-craft")
    @ApiOperation(value = "查询信息带分页", notes = "组合查询，外带分页功能")
    public ResultBean findMesCraft(MesCraft bean, Pager pager) {
        try {
            bean.setOrganizeCode(AuthUtilExt.getOrganizeCode());
            ListPager<MesCraft> listPager = mesCraftService.findMesCraft(bean, pager);
            return ResultBean.success("操作成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setListPager(listPager);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        }
    }
}
