package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCustomerCarModelService;
import cn.estsh.i3plus.ext.mes.api.base.IMesPartProdGroupService;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesCustomerCarModel;
import cn.estsh.i3plus.pojo.mes.bean.MesCustomerCarModelDetail;
import cn.estsh.i3plus.pojo.mes.bean.MesPartProdGroup;
import cn.estsh.i3plus.pojo.mes.bean.MesPartProdGroupDetail;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 客户车型配置
 */
@Api("客户车型")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesCustomerCarModel")
public class MesCustomerCarModelController extends BaseMesController<MesCustomerCarModel>{

    @Autowired
    private IMesCustomerCarModelService mesCustomerCarModelService;

    @GetMapping(value = "/find-mes-customer-car-model")
    @ApiOperation(value = "查询客户车型")
    public ResultBean findMesCustomerCarModel(MesCustomerCarModelDetail mesPartProdGroupDetail) {
        try {
            mesPartProdGroupDetail.setOrganizeCode(AuthUtilExt.getOrganizeCode());
            //查询汇总工单数量
            List<MesCustomerCarModel> mesPartProdGroupList = mesCustomerCarModelService.findMesCustomerCarModel(mesPartProdGroupDetail);
            return ResultBean.success("查询成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(mesPartProdGroupList);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }
}
