package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCustomerCarModelService;
import cn.estsh.i3plus.ext.mes.api.base.IMesCustomerPartService;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesArea;
import cn.estsh.i3plus.pojo.mes.bean.MesCustomerCarModel;
import cn.estsh.i3plus.pojo.mes.bean.MesCustomerCarModelDetail;
import cn.estsh.i3plus.pojo.mes.bean.MesCustomerPart;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 客户零件号
 */
@Api("客户零件关系")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesCustomerPart")
public class MesCustomerPartController extends BaseMesController<MesCustomerPart>{
    @Autowired
    private IMesCustomerPartService mesCustomerPartService;

    @GetMapping(value = "/find-mes-customer-part")
    @ApiOperation(value = "查询客户零件")
    public ResultBean findMesCustomerPart(MesCustomerCarModelDetail mesPartProdGroupDetail) {
        try {
            mesPartProdGroupDetail.setOrganizeCode(AuthUtilExt.getOrganizeCode());
            //查询汇总工单数量
            List<MesCustomerPart> mesCustomerPartList = mesCustomerPartService.findMesCustomerPart(mesPartProdGroupDetail);
            return ResultBean.success("查询成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(mesCustomerPartList);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }
}
