package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesPartProdGroupService;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.icloud.core.sdk.ICoreLabelTemplateCloud;
import cn.estsh.i3plus.icloud.core.sdk.ICoreMessageCloud;
import cn.estsh.i3plus.icloud.core.sdk.ICoreScheduleCloud;
import cn.estsh.i3plus.icloud.core.sdk.ICoreScheduleUtilCloud;
import cn.estsh.i3plus.pojo.base.bean.BaseResultBean;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesPartProdGroup;
import cn.estsh.i3plus.pojo.mes.bean.MesPartProdGroupDetail;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrder;
import cn.estsh.i3plus.pojo.platform.bean.SysLabelTemplate;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 零件生产组
 */
@Api("零件生产组")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesPartProdGroup")
public class MesPartProdGroupController extends BaseMesController<MesPartProdGroup>{

    @Autowired
    private IMesPartProdGroupService mesPartProdGroupService;
    @Autowired
    private ICoreScheduleUtilCloud coreScheduleUtilCloud;

    @GetMapping(value = "/find-mes-part-prod-group")
    @ApiOperation(value = "查询零件生产组")
    public ResultBean findMesPartProdGroup(MesPartProdGroupDetail mesPartProdGroupDetail) {
        try {
            mesPartProdGroupDetail.setOrganizeCode(AuthUtilExt.getOrganizeCode());
            //查询汇总工单数量
            List<MesPartProdGroup> mesPartProdGroupList = mesPartProdGroupService.findMesPartProdGroup(mesPartProdGroupDetail);
            return ResultBean.success("查询成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(mesPartProdGroupList);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }

    @GetMapping(value = "/sys-label-template/list-detail")
    @ApiOperation(value = "查询零件生产组")
    public ResultBean labelList() {
        try {
            SysLabelTemplate template = new SysLabelTemplate();
            BaseResultBean listDetail = coreScheduleUtilCloud.findList(template);
            return ResultBean.success("查询成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultList(listDetail.getResultList());
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }

}
