package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base.MesPartPtrDetailService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesPartPtr;
import cn.estsh.i3plus.pojo.mes.bean.MesPartPtrDetail;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * ptr零件
 */
@Api("ptr零件明细")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesPartPtrDetail")
public class MesPartPtrDetailController extends BaseMesController<MesPartPtrDetail> {

    @PostMapping(value = "/queryPtrDetail")
    @ApiOperation(value = "查询节拍列表")
    public ResultBean getPtrDetail(MesPartPtrDetail mesPartPtrDetail, Pager pager) {
        try {
            mesPartPtrDetail.setIsValid(1);
            mesPartPtrDetail.setOrganizeCode("1154");

            ListPager<MesPartPtrDetail> mesList = baseService.queryPager(mesPartPtrDetail, pager);
            return ResultBean.success("查询成功").setListPager(mesList)
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode());
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }
}
