package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesProdShiftRecordService;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesProdShiftRecord;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @Description: 开关班记录
 * @Author: gsz
 * @Date: 2024/5/25 18:16
 * @Modify:
 */
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesProdShiftRecord")
public class MesProdShiftRecordController extends BaseMesController<MesProdShiftRecord>{

    @Autowired
    private IMesProdShiftRecordService prodShiftRecordService;

    @GetMapping(value = "/query-prod-shift-record")
    @ApiOperation(value = "查询零件生产组")
    public ResultBean queryMesProdShiftRecord(MesProdShiftRecord mesProdShiftRecord) {
        try {
            mesProdShiftRecord.setOrganizeCode(AuthUtilExt.getOrganizeCode());
            //查询汇总工单数量
            MesProdShiftRecord mesPartProdGroup= prodShiftRecordService.queryMesProdShiftRecord(mesProdShiftRecord);
            return ResultBean.success("查询成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setResultObject(mesPartProdGroup);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e).build();
        } catch (Exception e) {
            return ResultBean.fail(e);
        }
    }
}
