package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesProductPlanService;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesProductPlan;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Description : SAP生产计划
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/6 15:53
 * @Modify:
 **/
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesProductPlan")
@Api("SAP生产计划")
public class MesProductPlanController extends BaseMesController<MesProductPlan> {

    @Autowired
    private IMesProductPlanService iMesProductPlanService;

    @GetMapping(value = "/query-by-pager")
    @ApiOperation(value = "分页查询SAP生产计划", notes = "分页查询SAP生产计划")
    public ResultBean queryMesProductPlanByPager(MesProductPlan mesProductPlan, Pager pager) {
        try {
            mesProductPlan.setOrganizeCode(AuthUtilExt.getOrganizeCode());
            ListPager<MesProductPlan> listPager = iMesProductPlanService.queryMesProductPlanPager(mesProductPlan, pager);
            return ResultBean.success("查询成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setListPager(listPager);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        }
    }

}
