package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesShiftService;
import cn.estsh.i3plus.ext.mes.apiservice.config.AuthUtilExt;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.MesShift;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesShift")

public class MesShiftController extends BaseMesController<MesShift> {

    @Autowired
    private IMesShiftService mesShiftService;

    @GetMapping(value = "/find")
    @ApiOperation(value = "查询班次信息", notes = "查询班次信息")
    public ResultBean findMesShift(MesShift mesShift) {
        try {
            mesShift.setOrganizeCode(AuthUtilExt.getOrganizeCode());
            List<MesShift> mesShiftList = mesShiftService.findMesShift(mesShift);
            return ResultBean.success("操作成功")
                    .setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode())
                    .setResultList(mesShiftList);
        } catch (ImppBusiException e) {
            return ResultBean.fail(e);
        }
    }

}
