package cn.estsh.i3plus.ext.mes.apiservice.controller.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesShippingOrderManagementDetailService;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.enumutil.ResourceEnumUtil;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesShippingOrderManagementDetail;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ResultBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Api("发运单管理明细")
@RestController
@RequestMapping(MesCommonConstant.MES_YANFEN + "/mesShippingOrderManagementDetail")

public class MesShippingOrderManagementDetailController extends BaseMesController<MesShippingOrderManagementDetail> {

    @Autowired
    private IMesShippingOrderManagementDetailService shippingOrderManagementDetailService;

    @PostMapping(value = "/query-group")
    @ApiOperation(value = "发运单管理明细-根据零件汇总")
    public ResultBean insertMesProdOrg(MesShippingOrderManagementDetail detail, Pager pager) {
        try {

            detail.setOrganizeCode(AuthUtil.getOrganize().getOrganizeCode());

            return ResultBean.success("添加成功").setCode(ResourceEnumUtil.MESSAGE.SUCCESS.getCode()).setListPager(shippingOrderManagementDetailService.queryDetailGroupByPartNo(detail,pager));
        } catch (ImppBusiException busExcep) {
            return ResultBean.fail(busExcep);
        } catch (Exception e) {
            return ImppExceptionBuilder.newInstance().buildExceptionResult(e);
        }
    }

}
