package cn.estsh.i3plus.ext.mes.apiservice.cus_suit;

import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.platform.plugin.datasource.DynamicDataSourceProxy;
import lombok.Getter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnExpression;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.concurrent.TimeUnit;

/**
 * @Description : mes 直连数据源
 * @Reference :
 * @Author : Rock.Yu
 * @CreateDate : 2019-06-13 20:40
 * @Modify:
 **/
@Configuration
//@PropertySource(value="classpath:/cus_config/cus-datasource.properties",encoding = "UTF-8")
public class MesProperties {

    public static final Logger LOGGER = LoggerFactory.getLogger(CommonConstWords.SYSTEM_LOG);

    /***********************
     * mes直连数据源配置
     */
    @Value("${impp.mes.datasource.isopen}")
    @Getter
    private boolean mesIsOpen;

    @Value("${impp.mes.datasource.driver-class-name}")
    @Getter
    private String mesDriverClassName;

    @Value("${impp.mes.datasource.alias}")
    @Getter
    private String mesDsAlias;

    @Value("${impp.mes.datasource.jdbc-url}")
    @Getter
    private String mesDsJdbcUrl;

    @Value("${impp.mes.datasource.username}")
    @Getter
    private String mesDsUsername;

    @Value("${impp.mes.datasource.password}")
    @Getter
    private String mesDsPassword;

    @ConditionalOnExpression("'${impp.mes.datasource.isopen:false}' == 'true'")
    @Bean(name = "mesDataSource")

    public DynamicDataSourceProxy initmesCustomerSet(){
        LOGGER.info("【初始化客户定制化-mes直连...】");
        /**
         * 注册客户定制数据源
         */
        LOGGER.info("【客户定制化：mes直连数据源加载...】");
        //安道拓定制业务
        DynamicDataSourceProxy mesDataSource = DynamicDataSourceProxy.initDataSourceFactory(this.getMesDriverClassName(),
                this.getMesDsJdbcUrl(),this.getMesDsUsername(),this.getMesDsPassword(),TimeUnit.MINUTES.toMillis(30));

        return mesDataSource;
    }
}
