package cn.estsh.i3plus.ext.mes.apiservice.cus_suit.yfas;

import cn.estsh.i3plus.platform.plugin.datasource.DynamicDataSourceProxy;
import cn.estsh.i3plus.pojo.mes.bean.BasVendor;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description : 安道拓服务
 * @Reference : 为了防止和原有事务Service拦截冲突，命名时注意不要使用service
 * @Author : alwaysfrin
 * @CreateDate : 2019-06-11 14:35
 * @Modify:
 **/
@Component
public class YfasBusiTool {

    @Resource(name="yfasDataSource")
    private DynamicDataSourceProxy dataSourceProxy;

    public void execute(String sql) throws SQLException {
        dataSourceProxy.execute(sql);
    }

    public void insert(String tableName,HashMap<String,Object> objMap) throws SQLException {
        dataSourceProxy.insert(tableName,objMap);
    }

    public void update(String tableName,HashMap<String,Object> conditionMap,HashMap<String,Object> setValueMap) throws SQLException {
        dataSourceProxy.update(tableName,conditionMap,setValueMap);
    }

    public void detelte(String tableName,HashMap<String,Object> conditionMap) throws SQLException {
        dataSourceProxy.delete(tableName,conditionMap);
    }

    public List<Map<String,Object>> listMap(String sql) throws SQLException {
        return dataSourceProxy.queryMapList(sql);
    }

    public BasVendor get(String sql) throws SQLException, IllegalAccessException, InstantiationException {
        return dataSourceProxy.queryObject(sql,BasVendor.class);
    }

    public List<BasVendor> listObject(String sql) throws SQLException, IllegalAccessException, InstantiationException {
        return dataSourceProxy.queryObjectList(sql,BasVendor.class);
    }

    public BasVendor get(String tableName,HashMap<String,Object> conditionMap) throws SQLException, IllegalAccessException, InstantiationException {
        return dataSourceProxy.queryObject(tableName,conditionMap,BasVendor.class);
    }

    public List<BasVendor> listObject(String tableName,HashMap<String,Object> conditionMap) throws SQLException, IllegalAccessException, InstantiationException {
        return dataSourceProxy.queryObjectList(tableName,conditionMap,BasVendor.class);
    }

    public int[] executeAsBatch(String[] sqlArr) throws SQLException {
        return dataSourceProxy.executeAsBatch(sqlArr);
    }
}
