package cn.estsh.i3plus.ext.mes.apiservice.dao;

import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipment;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCenter;
import cn.estsh.i3plus.pojo.mes.model.MesEquipmentModel;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : wangjie
 * @CreateDate : 2019-08-27
 * @Modify:
 **/
public interface IEquipmentExtDao {

    /**
     * 获取设备分页数据
     * @param mesEquipment
     * @param pager
     * @return
     */
    List<MesEquipmentModel> queryMesEquipmentByPager(MesEquipment mesEquipment, Pager pager);

    /**
     * 获取设备分页数据数量
     * @param mesEquipment
     * @return
     */
    int queryMesEquipmentByPagerCount(MesEquipment mesEquipment);

    /**
     * 获取设备分页数据-组织模型
     * @param mesEquipment
     * @param pager
     * @return
     */
    List<MesEquipmentModel> queryMesEquipmentByPagerOrg(MesEquipment mesEquipment, Pager pager);

    /**
     * 获取设备分页数据数量-组织模型
     * @param mesEquipment
     * @return
     */
    int queryMesEquipmentByPagerOrgCount(MesEquipment mesEquipment);

    /**
     * 根据生产线，工位获取设备集合
     * @param mesEquipment
     * @return
     */
    List<MesEquipmentModel> findMesEquipmentList(MesEquipment mesEquipment);

    /**
     * 根据条件查询设备所有有效数据-组织模型下拉框及联
     * @param mesEquipment
     * @return
     */
    List<MesEquipmentModel> queryMesEquipmentList(MesEquipment mesEquipment);

    /**
     * 根据条件查询设备所有有效数据-设备作业任务下拉框
     * @param mesEquipment
     * @return
     */
    List<MesEquipmentModel> queryMesEquipmentListByParams(MesEquipment mesEquipment);

    /**
     * 查询设备绑定的生产线
     * @param organizeCode
     * @param equipmentCode
     * @return
     */
    List<MesWorkCenter> getEquipmentWorkCenterCode(String organizeCode, String equipmentCode);

}
