package cn.estsh.i3plus.ext.mes.apiservice.dbinterface;

import cn.estsh.i3plus.pojo.base.codemaker.SnowflakeIdMaker;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.UUID;

/**
 * @Description :用于生成系统 ID、GUID
 * @Reference :
 * @Author : gsz
 * @CreateDate : 2024-05-10 16:08
 * @Modify:
 **/
@Component
public class WmsSAPDbID {

    // 获取 IMPP ID
    @Autowired
    private SnowflakeIdMaker snowflakeIdMaker;


    /**
     * 获取系统 ID，线程安全
     * @return
     */
    public synchronized long nextId() {
        return snowflakeIdMaker.nextId();
    }

    /**
     * 获取 GUID（Globals Unique Identifiers）
     * @return
     */
    public synchronized String guid() {
        return UUID.randomUUID().toString();
    }
}
