package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesBasDowntimeReasonService;
import cn.estsh.i3plus.platform.common.exception.ImppExceptionEnum;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesDowntimeReason;
import cn.estsh.impp.framework.boot.exception.ImppExceptionBuilder;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;


/**
 * @Description : Maximo仪表主数据
 * @Reference :
 * @Author : gsz
 * @CreateDate 2024/5/17 14:06
 * @Modify:
 **/
@Service
@Slf4j
public class MesBasDowntimeReasonServiceImpl extends BaseMesService<MesDowntimeReason> implements IMesBasDowntimeReasonService {

    @Override
    protected void setPackQueryBean(MesDowntimeReason bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getReasonCode(), "reasonCode", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getReasonName(), "reasonName", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getReasonTypeCode(), "reasonTypeCode", packBean);
    }
    @Override
    protected void onInsertBean(MesDowntimeReason item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getOrganizeCode(), "工厂号不能为空");
        ValidatorBean.checkNotNull(item.getReasonTypeCode(), "reasonTypeCode不能为空" );
        ValidatorBean.checkNotNull(item.getReasonCode(), "reasonCode不能为空");

        //唯一性校验
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getReasonCode(), "reasonCode", packBean);

        boolean flg = baseRDao.isExitByHql(packBean);
        if (flg) {
            throw ImppExceptionBuilder.newInstance()
                    .setSystemID(CommonEnumUtil.SOFT_TYPE.MES.getCode())
                    .setErrorCode(ImppExceptionEnum.VARIFY_EXCEPTION.getCode())
                    .setErrorDetail("类型代码【%s】已经存在，请检查数据", item.getReasonTypeCode())
                    .build();
        }
    }
}
