package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCustSoftInfoService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesCustSortInfo;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2024/6/2 20:39
 * @Modify:
 **/
@Service
public class MesCustSoftInfoServiceImpl extends BaseMesService<MesCustSortInfo> implements IMesCustSoftInfoService {
    @Override
    public List<MesCustSortInfo> queryCustSortInfoList(String custCode, String custOrganizeCode, String infoPointCode, String organizeCode, List<String> custPartNoList) {
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getStringEqualPack(custCode,"custCode", ddlPackBean);
        DdlPreparedPack.getStringEqualPack(custOrganizeCode, "custOrganizeCode", ddlPackBean);
        DdlPreparedPack.getStringEqualPack(infoPointCode, "infoPointCode", ddlPackBean);
        DdlPreparedPack.getInPackList(custPartNoList,"custPartNo", ddlPackBean);
        return baseRDao.findByHqlWhere(ddlPackBean);
    }

    @Override
    public void updateCustSortInfo(MesCustSortInfo custSortInfo) {
        ConvertBean.saveOrUpdate(custSortInfo,"edi");
        baseRDao.update(custSortInfo);

    }
}
