package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesProductPlanService;
import cn.estsh.i3plus.ext.mes.apiservice.dao.IMesProductPlanDao;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesProductPlan;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description :SAP生产计划
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/6 15:52
 * @Modify:
 **/
@Service
@Slf4j
public class MesProductPlanServiceImpl extends BaseMesService<MesProductPlan> implements IMesProductPlanService {

    @Autowired
    private IMesProductPlanDao iMesProductPlanDao;

    @Override
    protected void setPackQueryBean(MesProductPlan bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getPlanOrderNo(), "planOrderNo", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getPlanPartNo(), "planPartNo", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getPartMappingWorkCenterCode(), "partMappingWorkCenterCode", packBean);
        DdlPreparedPack.getStringBiggerPack(bean.getCreateDateTimeStart(), "createDatetime", packBean);
        DdlPreparedPack.getStringSmallerPack(bean.getCreateDateTimeEnd(), "createDatetime", packBean);
        DdlPreparedPack.getStringBiggerPack(bean.getPlanStartDate(), "planStartDate", packBean);
        DdlPreparedPack.getStringSmallerPack(bean.getPlanEndDate(), "planEndDate", packBean);
    }

    @Override
    public ListPager<MesProductPlan> queryMesProductPlanPager(MesProductPlan mesProductPlan, Pager pager) {
        return iMesProductPlanDao.queryMesProductPlanPager(mesProductPlan, pager);
    }

}
