package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkCellExtendCfgService;
import cn.estsh.i3plus.ext.mes.apiservice.unit.exception.MesException;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCellExtendCfg;
import cn.estsh.impp.framework.boot.util.ValidatorBean;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class MesWorkCellExtendCfgService extends BaseMesService<MesWorkCellExtendCfg> implements IMesWorkCellExtendCfgService {


    @Override
    protected void setPackQueryBean(MesWorkCellExtendCfg bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getWorkCellCode(), "workCellCode", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getWorkCenterCode(), "workCenterCode", packBean);
    }

    protected void onInsertBean(MesWorkCellExtendCfg item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getWorkCenterCode(), "产线不能为空");
        ValidatorBean.checkNotNull(item.getWorkCellCode(), "主工位不能为空");
        ValidatorBean.checkNotNull(item.getWorkCellCodeBak(), "子工位不能为空");

        DdlPackBean partPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getWorkCenterCode(), "workCenterCode", partPackBean);
        DdlPreparedPack.getStringEqualPack(item.getWorkCellCode(), "workCellCode", partPackBean);
        DdlPreparedPack.getStringEqualPack(item.getWorkCellCodeBak(), "workCellCodeBak", partPackBean);
        if (baseRDao.isExitByHql(partPackBean)) {
            MesException.throwMesBusiException("工作中心【%s】主工位【%s】子工位【%s】数据界已经存在，请检查数据",
                    item.getWorkCenterCode(),item.getWorkCellCode(),item.getWorkCellCodeBak());
        }

    }

    protected void onUpdateBean(MesWorkCellExtendCfg item) {
        // 数据校验
        ValidatorBean.checkNotNull(item.getWorkCenterCode(), "产线不能为空");
        ValidatorBean.checkNotNull(item.getWorkCellCode(), "主工位不能为空");
        ValidatorBean.checkNotNull(item.getWorkCellCodeBak(), "子工位不能为空");

        DdlPackBean partPackBean = DdlPackBean.getDdlPackBean(item.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(item.getWorkCenterCode(), "workCenterCode", partPackBean);
        DdlPreparedPack.getStringEqualPack(item.getWorkCellCode(), "workCellCode", partPackBean);
        DdlPreparedPack.getStringEqualPack(item.getWorkCellCodeBak(), "workCellCodeBak", partPackBean);
        DdlPreparedPack.getNumNOEqualPack(item.getId(), "id", partPackBean);
        if (baseRDao.isExitByHql(partPackBean)) {
            MesException.throwMesBusiException("工作中心【%s】主工位【%s】子工位【%s】数据界已经存在，请检查数据",
                    item.getWorkCenterCode(),item.getWorkCellCode(),item.getWorkCellCodeBak());
        }
    }

}
