package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.ext.mes.api.busi.IMesSpotCheckOrderResultService;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base.BaseMesService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesSpotCheckOrderResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

@Service
@Slf4j
public class MesSpotCheckOrderResultService extends BaseMesService<MesSpotCheckOrderResult> implements IMesSpotCheckOrderResultService {

    protected void setPackQueryBean(MesSpotCheckOrderResult bean, DdlPackBean packBean) {
        DdlPreparedPack.getNumEqualPack(bean.getPid(), "pid", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getTaskItemName(), "taskItemName", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getWorkCellCode(), "workCellCode", packBean);
        DdlPreparedPack.getNumEqualPack(bean.getIsTolerance(), "isTolerance", packBean);
        if (!StringUtils.isEmpty(bean.getSpotCheckTimeStart()) || !StringUtils.isEmpty(bean.getSpotCheckTimeEnd())) {
            DdlPreparedPack.timeBuilder(bean.getSpotCheckTimeStart(), bean.getSpotCheckTimeEnd(), "spotCheckTime", packBean, false);
        }
    }
}
