package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.excel;

import cn.estsh.i3plus.mes.api.iservice.busi.IExcelImportService;
import cn.estsh.i3plus.mes.apiservice.serviceimpl.busi.CommonService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.mes.bean.MesCarSeries;
import cn.estsh.i3plus.pojo.mes.bean.MesCarSeriesModel;
import cn.estsh.i3plus.pojo.mes.bean.MesPartPtr;
import cn.estsh.i3plus.pojo.mes.model.ExcelImportErrorModel;
import cn.estsh.i3plus.pojo.mes.model.ExcelImportResultModel;
import cn.estsh.i3plus.pojo.mes.repository.MesPartPtrRepository;
import cn.estsh.i3plus.pojo.mes.repository.MesPartRepository;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @CreateDate 2022/6/27 17:28
 * @Author 尹肖
 */
@Service
@Slf4j
public class MesCarSeriesExcelService implements IExcelImportService {

    @Autowired
    private CommonService commonService;
    @Autowired
    private MesPartRepository partRepository;
    @Autowired
    private MesPartPtrRepository partPtrRepository;

    @Override
    public ExcelImportResultModel insertDataByExcel(Workbook workbook, String organizeCode, String userName) {

        //读取表格
        ExcelImportResultModel excelImportResultModel = this.sheetExtractMesStationBom(workbook.getSheetAt(0), organizeCode, userName);
        //数据入库
        this.insertExcelMesPartPtr(excelImportResultModel);
        return excelImportResultModel;
//        return null;
    }

    /**
     * 工位BOM表导入-读取表格
     *
     * @param sheetAt
     * @param organizeCode
     * @param userName
     * @return
     */
    private ExcelImportResultModel sheetExtractMesStationBom(Sheet sheetAt, String organizeCode, String userName) {

        //从0行开始读取
        int totalNumberOfRows = sheetAt.getLastRowNum() + 1;

        //MesStationBom集合
        List<MesPartPtr> partPtrList = new ArrayList<>();

        //成功数量
        Integer successRowNum = 0;
        //失败数量
        Integer failRowNum = 0;
        //错误的行号
        String errorRows = "";

        //错误行信息集合
        List<ExcelImportErrorModel> excelImportErrorModels = new ArrayList<>();

        Map<String, String> map = new HashMap<>();

        for (int i = (sheetAt.getFirstRowNum() + 1); i < totalNumberOfRows; i++) {
            Row row = sheetAt.getRow(i);
            //空行跳过
            if (null == row) {
                continue;
            }
            //获取总列数
            Short lastCellNum = row.getLastCellNum();
            if (lastCellNum > 0) {

                int rowNum = i + 1;    //当前行号
                int errorNum = 0;      //错误数量
                String cellNum = "";   //错误列号
                String errorInfo = ""; //错误信息

                //车系代码
                String carSeriesCode = row.getCell(0, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();

                //车系名称
                String carSeriesName = null;
                try {
                    row.getCell(1).setCellType(CellType.STRING);
                    carSeriesName = row.getCell(1, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //客户代码
                String custCode = null;
                try {
                    row.getCell(2).setCellType(CellType.STRING);
                    custCode = row.getCell(2, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //客户工厂代码
                String custOrganizeCode = null;
                try {
                    row.getCell(3).setCellType(CellType.STRING);
                    custOrganizeCode = row.getCell(3, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //年型
                String yearModel = null;
                try {
                    row.getCell(4).setCellType(CellType.STRING);
                    yearModel = row.getCell(4, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //客户车型
                String custCarType = null;
                try {
                    row.getCell(5).setCellType(CellType.STRING);
                    custCarType = row.getCell(5, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //车系条码
                String carSeriesSn = null;
                try {
                    row.getCell(6).setCellType(CellType.STRING);
                    carSeriesSn = row.getCell(6, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //零件组
                String partGroup = null;
                try {
                    row.getCell(7).setCellType(CellType.STRING);
                    partGroup = row.getCell(7, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //车型代码
                String carModelCode = null;
                try {
                    row.getCell(8).setCellType(CellType.STRING);
                    carModelCode = row.getCell(8, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //车型名称
                String carModelName = null;
                try {
                    row.getCell(9).setCellType(CellType.STRING);
                    carModelName = row.getCell(9, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //颜色
                String carModelColor = null;
                try {
                    row.getCell(10).setCellType(CellType.STRING);
                    carModelColor = row.getCell(10, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //条码参数
                String snParam = null;
                try {
                    row.getCell(11).setCellType(CellType.STRING);
                    snParam = row.getCell(11, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //打印参数
                String printParam = null;
                try {
                    row.getCell(12).setCellType(CellType.STRING);
                    printParam = row.getCell(12, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //零件号
                String partNo = null;
                try {
                    row.getCell(13).setCellType(CellType.STRING);
                    partNo = row.getCell(13, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //客户零件号
                String custPartNo = null;
                try {
                    row.getCell(14).setCellType(CellType.STRING);
                    custPartNo = row.getCell(14, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //散件类型
                String loosePartType = null;
                try {
                    row.getCell(14).setCellType(CellType.STRING);
                    loosePartType = row.getCell(14, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //显示顺序
                String displaySeq = null;
                try {
                    row.getCell(15).setCellType(CellType.STRING);
                    displaySeq = row.getCell(15, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //显示名称
                String displayName = null;
                try {
                    row.getCell(16).setCellType(CellType.STRING);
                    displayName = row.getCell(16, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //装饰条颜色
                String trimStripColor = null;
                try {
                    row.getCell(17).setCellType(CellType.STRING);
                    trimStripColor = row.getCell(17, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }
                //装饰条颜色
                String remark = null;
                try {
                    row.getCell(18).setCellType(CellType.STRING);
                    remark = row.getCell(18, Row.MissingCellPolicy.CREATE_NULL_AS_BLANK).getStringCellValue().trim();
                } catch (Exception e) {
                }


                //没有错误的时候，封装MesStationBom
                if (errorNum == 0) {

                    MesCarSeries carSeries = new MesCarSeries();

                    carSeries.setCarSeriesCode(carSeriesCode);
                    carSeries.setCarSeriesName(carSeriesName);
                    carSeries.setCustCode(custCode);
                    carSeries.setCustOrganizeCode(custOrganizeCode);
                    carSeries.setYearModel(yearModel);
                    carSeries.setCustCarType(custCarType);
                    carSeries.setCarSeriesSn(carSeriesSn);
                    carSeries.setPartGroup(partGroup);
                    carSeries.setOrganizeCode(organizeCode);
                    ConvertBean.serviceModelInitialize(carSeries, AuthUtil.getSessionUser().getUserName());

                    MesCarSeriesModel model = new MesCarSeriesModel();
                    model.setCarSeriesCode(carSeriesCode);
                    model.setCarSeriesName(carSeriesName);
                    model.setCarModelCode(carModelCode);
                    model.setCarModelName(carModelName);
                    model.setCarModelColor(carModelColor);

                    successRowNum++;
                } else {
                    //封装错误行信息ExcelImportErrorModel
                    excelImportErrorModels = commonService.getExcelImportErrorModels(excelImportErrorModels, rowNum, errorNum, cellNum, errorInfo);

                    errorRows += rowNum + ";";
                    failRowNum++;
                }

            }
        }

        //校验EXCEL数据
        commonService.checkExcelData(failRowNum, successRowNum, errorRows);
        //封装返回结果
        ExcelImportResultModel excelImportResultModel = commonService.getExcelImportResultModel(failRowNum, successRowNum, excelImportErrorModels, errorRows);
        excelImportResultModel.setExcelList((failRowNum > 0) ? null : partPtrList);
        return excelImportResultModel;
    }

    private void insertExcelMesPartPtr(ExcelImportResultModel excelImportResultModel) {
        if (excelImportResultModel == null) {
            return;
        }
        List<MesPartPtr> partPtrList = excelImportResultModel.getExcelList();
        if (CollectionUtils.isEmpty(partPtrList)) {
            return;
        }

        partPtrList.forEach(k -> {
            if (StringUtils.isEmpty(k.getId())) {
                partPtrRepository.insert(k);
            } else {
                partPtrRepository.update(k);
            }
        });
    }
}
