package cn.estsh.i3plus.ext.mes.icloud.sdk;

import cn.estsh.i3plus.ext.mes.icloud.sdkfallback.MesForWmsFactory;
import cn.estsh.i3plus.ext.mes.pojo.constant.MesCommonConstant;
import cn.estsh.i3plus.pojo.base.bean.BaseResultBean;
import cn.estsh.i3plus.pojo.model.wms.WmsProductModel;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @Description :
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/13 19:23
 * @Modify:
 **/
@FeignClient(name = "i3mes", //对应配置文件中的spring.application.name
        path = MesCommonConstant.MES_YANFEN + "/mesWorkOrder",
        fallbackFactory = MesForWmsFactory.class)
public interface IMesForWmsCloud {


    /**
     * MES移库cloud
     *
     * @return 结果封装
     */
    @PostMapping(value = "/report-work-reversal")
    @ApiOperation(value = "反向冲销")
    BaseResultBean doReportWorkReversal(@RequestBody WmsProductModel model);

}
