package cn.estsh.i3plus.ext.mes.icloud.sdkfallback;

import cn.estsh.i3plus.ext.mes.icloud.sdk.IMesForWmsCloud;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.bean.BaseFallBackBean;
import cn.estsh.i3plus.pojo.base.bean.BaseResultBean;
import cn.estsh.i3plus.pojo.model.wms.WmsProductModel;
import feign.hystrix.FallbackFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

/**
 * @Description :
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/13 19:13
 * @Modify:
 **/
@Component
public class MesForWmsFactory extends BaseFallBackBean implements FallbackFactory<IMesForWmsCloud> {

    private static final Logger LOGGER = LoggerFactory.getLogger(CommonConstWords.SYSTEM_LOG);


    @Override
    public IMesForWmsCloud create(Throwable cause) {
        return new IMesForWmsCloud() {
            @Override
            public BaseResultBean doReportWorkReversal(WmsProductModel model) {
                return makeBaseFallBack("微服调用出错", cause);
            }
        };
    }
}
